library ExISAP1;

  uses
    Windows,
    SysUtils,
    GenSuppt,
    WebSBTL;

  const
    ModuleDesc = 'ExISAP1 1.0';
    ModuleName = 'ExISAP1.dll';

{***********************************************************
*                                               DllMain    *
***********************************************************}
procedure DllMain (fdwReason : DWORD);
begin
  Case fdwReason of
    DLL_PROCESS_ATTACH : ;
    DLL_PROCESS_DETACH : ;
  end;
end;

{***********************************************************
*                                   GetExtensionVersion    *
***********************************************************}
function GetExtensionVersion(Var VerInfo : THseVersionInfo) : BOOL; Export; StdCall;
begin
  VerInfo.ExtensionVersion := MAKELONG(HSE_VERSION_MINOR, HSE_VERSION_MAJOR);
  StrPCopy( VerInfo.ExtensionDesc, ModuleDesc);
  Result := True;
end;


{***********************************************************
*                                     HttpExtensionProc    *
***********************************************************}
function HttpExtensionProc (Var ECB : TEcb) : Cardinal; export; stdcall;
var
  WebConn     : TIsapiExt;     // This must be a local var since each connection will have its own unique ECB
begin
  WebConn := TIsapiExt.Create (@ECB);
  try
    With WebConn do begin
      HTTPHeader;
      HTMLBegin ('TBrowser Demo', '', '');
      BodyBegin;
      Send ('<center>');
      TableBegin(default, 1, '', '');
      TableSendRow(['Browser', UserAgent.Browser]);
      TableSendRow(['Version', UserAgent.Version]);
      TableSendRow(['Parent', UserAgent.Parent]);
      TableSendRow(['Platform', UserAgent.Platform]);
      TableSendRow(['Frames', UserAgent.Frames]);
      TableSendRow(['Tables', UserAgent.Tables]);
      TableSendRow(['Cookies', UserAgent.Cookies]);
      TableSendRow(['Background Sounds', UserAgent.BgSounds]);
      TableSendRow(['VB Script', UserAgent.VbScript]);
      TableSendRow(['JavaScript', UserAgent.JavaScript]);
      TableEnd;
      Send ('</center>');
      BodyEnd;
      HTMLEnd;
    end;
  except
    On E: Exception do
     WriteAppEventLog('browcap.dll', ' -- Class :'+ E.ClassName + ' -- Message :' + E.Message, EVENTLOG_ERROR_TYPE, 100)
  end;
  WebConn.Free;
  result := HSE_STATUS_SUCCESS;
end;


Exports
  HttpExtensionProc,
  GetExtensionVersion;

begin
  DLLProc := @DllMain;
  DllMain (DLL_PROCESS_ATTACH);
end.


