{$A+}

Library ExIsap2;

Uses
  Windows,
  SysUtils,
  GenSuppt,
  WebSBTL;

  const
    idAccountSignUpForm = 4321;
    ModuleDesc   = 'Account Signup Module';
    ModulePath   = '/scripts/ExIsap2.dll';
    txtUserName  = 'txtUserName';
    txtAddress   = 'txtAddress';
    txtCity      = 'txtCity';
    txtState     = 'txtState';
    txtAcctType  = 'txtAcctType';
    txtSubmit    = 'Submit';

  const
    AcctTypes : Array [1..3] of String = ('Novice', 'Intermediate', 'Master');
    Cities    : Array [1..4] of String = ('Chicago', 'Dallas', 'New York', 'Seattle');


  function GetExtensionVersion (var VerInfo : THseVersionInfo) : BOOL; export; stdcall;
  begin
    VerInfo.ExtensionVersion := MAKELONG(HSE_VERSION_MINOR,
                                         HSE_VERSION_MAJOR);
    StrPCopy( VerInfo.ExtensionDesc, ModuleDesc);
    Result := True;
  end;


  Function HttpExtensionProc (Var ECB : TEcb) : Cardinal; export; stdcall;
  var
    WebConn : TISAPIExt;

    function AccountTypeVal(strAcctType : String) : Byte;
    begin
      result := 1;
      if strAcctType = AcctTypes[2] then result := 2
      else
        if strAcctType = AcctTypes[3] then result := 3;
    end;

    procedure FormSignUp;
    begin
      With WebConn do begin
        Send ('<blockquote>');
        CenterOn;
        FormBegin (idAccountSignUpForm, POST, ModulePath, URL_DEFAULT);
        Send ('User Name: ');
        TextField(txtUserName, iif(GetFormVar(txtUserName, False) <> '' ,
                  GetFormVar(txtUserName, False), 'John Smith'), 20, 30);
        Send ('&nbsp;&nbsp;&nbsp;Address: ');
        TextField(txtAddress, iif(GetFormVar(txtAddress, False) <> '' ,
                  GetFormVar(txtAddress,False), '1406 Stemmons Pkwy'), 20, 35);
        Send ('<p>City: ');
        PullDownListBegin(txtCity);
        PullDownListAdd('Chicago', '0', GetFormVar(txtCity, False) = '0');
        PullDownListAdd('Dallas', '1', GetFormVar(txtCity, False)='1');
        PullDownListAdd('New York', '2', GetFormVar(txtCity, False)='2');
        PullDownListAdd('Seattle', '3', GetFormVar(txtCity, False)='3');
        PullDownListEnd;
        Send ('&nbsp;&nbsp;&nbsp;State: ');
        TextField(txtState, iif(Length(GetFormVar(txtState, False)) > 0 ,
                  GetFormVar(txtState, False), 'TX'), 2, 2);
        Send ('&nbsp;&nbsp;&nbsp;Account Type: ');
        ListBox(txtAcctType, AcctTypes, AccountTypeVal(GetFormVar(txtAcctType, False)));
        NewPara;
        SubmitButton(txtSubmit, txtSubmit);
        CenterOff;
        FormEnd;
        Send ('</blockquote>');
      end;
    end;

  begin
    WebConn := TISAPIExt.Create(@ECB);
    With WebConn do begin
      HTTPHeader;
      HTMLBegin ('Account Signup Form', '', '');
      CustomBodyBegin('', '#000000', '#FFFFFF', '', '', '');
      Case RequestMethod of
        GET  : begin
          if QueryCount = 0 then
          begin
            Header(2, 'Please fill out the account form', true);
            FormSignUp
          end
          else
            ShowBadRequest('');
        end;

        POST : begin
          Case FormID of
            idAccountSignUpForm : begin
              Send ('<blockquote>');
              Header(2, 'Thank you for filling out the form ' + GetFormVar(txtUserName, False), true);
              Send ('The information you filled in was: ');
              Send ('<blockquote>');
              Send (GetFormVar(txtUserName, False) + ' - ' + GetFormVar(txtAcctType, False) + '<br>');
              Send (GetFormVar(txtAddress, False) + '<br>');
              Send (Cities[StrToInt(GetFormVar(txtCity, False))+1] + ', ');
              Send (GetFormVar(txtState, False) + '<br>');
              Send ('</blockquote>');
              Send ('</blockquote>');
              FormSignUp;
            end;
          else
            ShowBadRequest('');
          end;
        end;
      end;
    end;
    WebConn.Free;
    result := HSE_STATUS_SUCCESS;
  end;

exports
  HttpExtensionProc,
  GetExtensionVersion;

end.

